package condition

import (
	"context"
	"service/internal/infrastructure/database"
	"service/pkg/utils/query"
)

type Repository interface {
	GetNextCondition(ctx context.Context, lastID int64) (*ConditionDB, error)
	SaveSatuSehatID(ctx context.Context, idx int64, fhirID string) error
	SaveSyncLog(ctx context.Context, logData ConditionSyncLog) error
}

type repository struct {
	dbManager database.Service
}

func NewRepository(dbManager database.Service) Repository {
	return &repository{dbManager: dbManager}
}

func (r *repository) GetNextCondition(ctx context.Context, lastID int64) (*ConditionDB, error) {
	var cond ConditionDB
	simrsDB, err := r.dbManager.GetSQLXDB("simrs")
	if err != nil {
		return nil, err
	}

	qb := query.NewSQLQueryBuilder(query.DBTypePostgreSQL).SetSecurityOptions(false, 0)

	// TODO: Sesuaikan dengan nama tabel diagnosa di SIMRS Anda
	qSimrs := query.DynamicQuery{
		From: "public.t_diagnosa",
		Filters: []query.FilterGroup{
			{
				Filters: []query.DynamicFilter{
					query.CreateFilter("idxdiagnosa", query.OpGreaterThan, lastID),
				},
			},
		},
		Sort: []query.SortField{
			query.CreateAscSort("idxdiagnosa"),
		},
		Limit: 1,
	}

	err = qb.ExecuteQueryRow(ctx, simrsDB, qSimrs, &cond)
	if err != nil {
		return nil, err
	}
	return &cond, nil
}

func (r *repository) SaveSatuSehatID(ctx context.Context, idx int64, fhirID string) error {
	simrsDB, err := r.dbManager.GetSQLXDB("simrs")
	if err != nil {
		return err
	}

	qb := query.NewSQLQueryBuilder(query.DBTypePostgreSQL).SetSecurityOptions(false, 0)
	updateData := query.UpdateData{
		Columns: []string{"status_bridging"},
		Values:  []interface{}{fhirID},
	}
	filters := []query.FilterGroup{
		query.CreateAndFilterGroup([]query.DynamicFilter{query.CreateEqualFilter("idxdiagnosa", idx)}),
	}

	_, err = qb.ExecuteUpdate(ctx, simrsDB, "public.t_diagnosa", updateData, filters)
	return err
}

func (r *repository) SaveSyncLog(ctx context.Context, logData ConditionSyncLog) error {
	simrsDB, err := r.dbManager.GetSQLXDB("simrs")
	if err != nil {
		return err
	}

	qb := query.NewSQLQueryBuilder(query.DBTypePostgreSQL).SetSecurityOptions(false, 0)
	insertData := query.InsertData{
		Columns: []string{"idxdiagnosa", "condition_id", "request_payload", "response_payload", "status", "error_message"},
		Values: []interface{}{
			logData.IdxDiagnosa, logData.ConditionID, logData.RequestPayload,
			logData.ResponsePayload, logData.Status, logData.ErrorMessage,
		},
	}
	conflictCols := []string{"idxdiagnosa"}
	updateCols := []string{"condition_id", "request_payload", "response_payload", "status", "error_message"}
	_, err = qb.ExecuteUpsert(ctx, simrsDB, "public.log_satusehat_condition", insertData, conflictCols, updateCols)
	return err
}
